/*
Showkeys
 
This program diplays the A/D value for each key pressed on the 
 LCD Display board.  It is simply a dianostic program
with little in the way of a user interface.

The hardware assumes a bipolar stepper motor with a TB6065 driver board
and the Sainsmart LCD/keypad sheild with two TMP36 temp sensors

Created Aug 2013 by Gary Liming 

*/

//First, include some files for the LCD display, and its motor

#include <Arduino.h>
#include <LiquidCrystal.h>


LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  //Numbers for the Sainsmart

// define buttons
#define NO_KEY 0
#define SELECT_KEY 1
#define LEFT_KEY 2
#define UP_KEY 3
#define DOWN_KEY 4
#define RIGHT_KEY 5

// create global variables

int    cur_key;


void setup()
{
//  Create some custom characters for the lcd display

  // begin program
  
  lcd.begin(16, 2);
  lcd.clear();
  lcd.setCursor(0,0);                 // display flash screen
  lcd.print("Showkeys");
  delay(1500);                        // wait a few secs
  lcd.clear();
  
}                                    // end of setup function

void loop()                          // main loop servicing keystrokes
{ 
  lcd.clear();
  lcd.print("Key = ");
  lcd.setCursor(6,0);
  lcd.print(get_real_key());           // grab a keypress
  delay(500);
 
}

int get_real_key(void)    // routine to return a valid keystroke
{
  int trial_key = 0;
  read_LCD_button();
  while ((trial_key < 5) || (trial_key > 1021))
  {
    delay(10);
    trial_key = read_LCD_button(); 
  }
  delay(10);
  //trial_key  = read_LCD_button(); 
  delay(10);             // 100 millisec delay between user keys
  return trial_key;
}  

int read_LCD_button()     // routine to read the LCD's buttons
{
  return(analogRead(0));      // read ADC
} 

